import csv
import hashlib

import sys
import os
modules_path = '../../../modules/'
if os.path.exists(modules_path):
    sys.path.insert(1, modules_path)

from messaging.MessageHandler import MessageHandler

# file to read the data from
CSV_FILE = r'Energy_Dataset.csv'
handler = MessageHandler()


def upload_transaction(transaction):
    '''{"type": "new-trace", 
    "content": {"use_case": "paper", "table": "paper", "id": "dd2c5146c919b046d77a32a5cf553d5133163562f7b7e1298c878c575d516025", 
    "properties": {"Customer": "297", "Energy_Consumption_kWh": "0.177", "Heating_Consumption_kWh": "0.0", "Latitude": "-33.362679", "Longitude": "151.447302", "Postcode": "2261", "Price_AUD_MWh": "58.05", "Solar_Production_kWh": "0.0", "Timestamp": "2013-06-30 00:00:00", "Total_Demand_MWh": "8154.14", "UniqueID": "dd2c5146c919b046d77a32a5cf553d5133163562f7b7e1298c878c575d516025"}
    }}'''
    uid = hashlib.sha256(f"{transaction['Customer']}{transaction['Timestamp']}".encode("utf-8")).hexdigest()
    transaction['UniqueID'] = uid
    t = {        
        'use_case': 'paper',
        'table': 'paper',
        'id': uid,
        'properties': transaction
    }
    handler.handle_new_trace(t)


if __name__ == '__main__':    
    with open(CSV_FILE, 'r') as file:
        reader = csv.reader(file)

        titles = next(reader)

        #################
        maxCustomers = 5
        maxRows = 10
        ##################

        old_c = None
        customersCount = 0
        rowCount = 0
        for row in reader:
            
            transaction = {}
            transaction['ApplicationType'] = 'paper'
            transaction['docType'] = 'paper'
            for idx in range(len(row)):
                transaction[titles[idx]] = row[idx]

            if transaction['Customer'] != old_c:  
                customerCount +=1    
                rowCount = 0
                old_c = transaction['Customer']
                print(f"uploading for {old_c}")

            if(rowCount<maxRows):
                upload_transaction(transaction)
            rowCount+=1
            
            if (customerCount>maxCustomers-1):
                print("\nMAX customers reached")
                break


